# -*- coding: utf-8 -*-
import xbmc, xbmcgui, xbmcplugin
import sys
try:
    from urllib2 import urlopen
except ImportError:
    from urllib.request import urlopen
try:
    from urllib import urlencode
except ImportError:
    from urllib.parse import urlencode
try:
    from urlparse import urlparse, parse_qs
except ImportError:
    from urllib.parse import urlparse, parse_qs
if sys.version_info < (2, 7) or (3, 0) <= sys.version_info < (3, 1):
    import simplejson as json
    from simplejson import OrderedDict
else:
    import json
    from collections import OrderedDict
import cntv


def play(title, url):
    listitem = xbmcgui.ListItem(title)
    xbmc.Player().play(url, listitem)


def resp(ret):
    if 'code' in ret:
        if 'error' in ret:
            return xbmcgui.Dialog().ok('Error: ' + ret['code'], ret['error'])
        return xbmcgui.Dialog().ok('Error', ret['code'])
    if isinstance(ret, list):
        xbmcplugin.setContent(handle, 'videos')
        for elem in ret:
            resp(elem)
        return xbmcplugin.endOfDirectory(handle)
    if 'url' in ret:
        if isinstance(ret['url'], list):
            ret['url'] = 'stack://' + ' , '.join(ret['url'])
        if isinstance(ret['url'], dict):
            for k, v in ret['url'].items():
                resp({'title': ret['title'], 'url': v, 'format': k})
            return xbmcplugin.endOfDirectory(handle)
    if 'final' in ret:
        return play(ret['title'], ret['url'])
    t = True
    if 'format' in ret:
        li = xbmcgui.ListItem(ret['format'])
        ret['final'] = True
        t = False
    else:
        li = xbmcgui.ListItem(ret['title'])
    if 'img' in ret:
        li.setThumbnailImage(ret['img'])
    if 'plot' in ret:
        li.setInfo('video', {'plot': ret['plot']})
    if 'url' in ret:
        if ret['url'][:8] == 'stack://':
            return xbmcplugin.addDirectoryItem(handle, ret['url'], li)
        o = urlparse(ret['url'])
        p = o.path.split('/')
        ext = p[-1].split('.')[-1]
        if ext in ('m3u', 'm3u8'):
            return xbmcplugin.addDirectoryItem(handle, ret['url'], li)
        if t:
            t = sub1(ret['url'])
    for k in ret:
        if isinstance(ret[k], unicode):
            ret[k] = ret[k].encode('utf-8')
    xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urlencode(ret), li, t)


def sub1(url):
    o = urlparse(url)
    p = o.path.split('/')
    while p and not p[-1]:
        p = p[:-1]
    if o.netloc[-9:] == '.cctv.com' and p[-1][:4] == 'VIDE' and p[-1][-6:] == '.shtml':
        return False
    if o.netloc[-8:] == '.cntv.cn' and p[1] == 'video':
        return False
    # if o.netloc == 'vdn.live.cntv.cn':
    #	return False
    return True


def sub2(url):
    o = urlparse(url)
    p = o.path.split('/')
    while p and not p[-1]:
        p = p[:-1]
    if o.netloc[-9:] == '.cctv.com':
        # http://tv.cctv.com/lm/tsfx/videoset/index.shtml
        if p[1] == 'lm':
            return resp(cntv.lm(url))
        # http://tv.cctv.com/2017/08/01/VIDATpMb8AuFgveEQWuoBhJN170801.shtml
        if p[-1][:4] == 'VIDA' and p[-1][-6:] == '.shtml':
            return resp(cntv.vida(url))
        # http://tv.cctv.com/2020/01/02/VIDEKBknjsr1ruhYhUNaFqKl200102.shtml
        if p[-1][:4] == 'VIDE' and p[-1][-6:] == '.shtml':
            return resp(cntv.play(url))
    if o.netloc[-8:] == '.cntv.cn':
        # http://tv.cntv.cn/videoset/VSET100169831220
        # http://tv.cntv.cn/videoset/C14092
        if o.netloc[-8:] == '.cntv.cn' and p[1] == 'videoset':
            return resp(cntv.vset(url))
        # http://tv.cntv.cn/video/VSET100169831220/989a30af701e4de0b90eadde452adc51
        # http://tv.cntv.cn/video/C14092/bf544ab8f9744ef5ac3d55fc75ba4dc3
        if o.netloc[-8:] == '.cntv.cn' and p[1] == 'video':
            return resp(cntv.play(url))
    # http://api.cntv.cn/lanmu/videolistByColumnId?id=TOPC1451557893544236&serviceId=tvcctv&type=0&n=36&p=1&t=json
    if o.netloc == 'api.cntv.cn':
        return resp(cntv.videolist(url))
    # elif o.netloc == 'vdn.live.cntv.cn':
    #	ret = cntv.live(url)
    return resp({'code': 'cntv 020', 'error': url})


def sub3(content):
    try:
        data = json.loads(content, object_pairs_hook=OrderedDict)
    except Exception as e:
        return resp({'code': 'cntv 030', 'error': str(e)})
    for k, v in data.items():
        if isinstance(v, dict):
            resp({'title': k, 'json': json.dumps(v)})
        else:
            resp({'title': k, 'url': v})
    xbmcplugin.endOfDirectory(handle)


def get_node(url):
    try:
        content = urlopen(url).read().decode('utf-8')
    except Exception as e:
        return resp({'code': 'cntv 010', 'error': str(e)})
    sub3(content)


handle = int(sys.argv[1])
url = sys.argv[2]
if not url:
    get_node('http://ims.tian-le.com/cntv.json')
else:
    o = urlparse(url)
    q = parse_qs(o.query, True)
    if 'final' in q:
        play(q['title'][0], q['url'][0])
    elif 'json' in q:
        sub3(q['json'][0])
    elif 'url' in q:
        sub2(q['url'][0])
